import SessionManager from "../auth/SessionManager";
import { EndPoints, postData, getData } from "../services/AccessAPI";
import { useLocation, useNavigate } from 'react-router-dom';
import { useState, useEffect } from 'react';
import { Routes } from "../services/Routes";
import Select from 'react-select'
import TextInput from "../ui-elements/controls/input/TextInput";
import CheckBox from "../ui-elements/controls/input/CheckBox";

export default function CreateIntegration() {
    const search = useLocation().search;
    const id = new URLSearchParams(search).get('id')

    useEffect(() => {

    }, [id])

    let navigate = useNavigate();

    const [name, setName] = useState("");
    const [apiUrl, setApiUrl] = useState("");
    const [type, setType] = useState("TransactionImporter");

    const [loading, setLoading] = useState(true);

    function onSubmit(e) {
        e.preventDefault();

        let IntegrationObj = {
            name: name,
            apiUrl: apiUrl,
            type: type,
        }

        postData(EndPoints.INTEGRATIONS, IntegrationObj).then((result) => {
            setLoading(false);
            let responseJson = result;
            if (responseJson) {
                navigate(Routes.INTEGRATIONS);
            }
        });
    }

    function onClickBack(e){
        e.preventDefault();

        if(SessionManager.getToken()){
            navigate(Routes.INTEGRATIONS);
        }else{
            navigate(Routes.LOGIN);
        }   
    }

    return (
        <div className="row">
            <div className="col-md-12">
                <h3>Register new Integration</h3>
                <hr />
                <form onSubmit={onSubmit}>
                    <div className="row">
                        <div className="col-md-4">
                            <div className="form-group">
                                <label className="control-label">Integration Name: </label>
                                <TextInput
                                    className="form-control"
                                    value={name}
                                    onChange={(e) => setName(e.target.value)}
                                    name="name"
                                />
                            </div>

                            <div className="form-group">
                                <label className="control-label">API Url: </label>
                                <TextInput
                                    className="form-control"
                                    value={apiUrl}
                                    onChange={(e) => setApiUrl(e.target.value)}
                                    name="apiUrl"
                                />
                            </div>

                            <div className="form-group">
                                <label className="control-label">Type: </label>
                                <TextInput
                                    className="form-control"
                                    value={type}
                                    onChange={(e) => setType(e.target.value)}
                                    name="type"
                                />
                            </div>
                        </div>

                        <br />
                        <div className="form-group">
                            <input type="button" value="Cancel" onClick={onClickBack} className="btn btn-primary"></input>
                            &nbsp;&nbsp;
                            <input type="submit" value="Register Integration" className="btn btn-success"></input> 
                        </div>

                        <div className="col-md-8">
                        </div>
                    </div>
                </form>
            </div>
        </div>
    );
}