import { useNavigate } from "react-router-dom";
import { EndPoints, deleteData, getData } from "../services/AccessAPI";
import { useEffect } from "react";
import { useState } from 'react';
import { useLocation } from 'react-router-dom';
import { Routes } from "../services/Routes";

export default function DeleteIntegration() {
    const search = useLocation().search;
    const id = new URLSearchParams(search).get('id')

    useEffect(() => {
        getData(EndPoints.INTEGRATIONS + "/" + id).then(
            (result) => {
                if (result) {
                    setState({
                        name: result.name,
                        version: result.version,
                        apiUrl: result.apiUrl,
                        type: result.type,
                        loading: false
                    });
                }
            }
        );
    }, [id])

    let navigate = useNavigate();

    const [state, setState] = useState({
        name: '',
        version: '',
        apiUrl: '',
        type: '',
        loading: true
    });

    function onCancel() {
        navigate(Routes.INTEGRATIONS);
    }

    function onConfirmation(e) {
        e.preventDefault();

        deleteData(EndPoints.INTEGRATIONS + "/" + id).then((result) => {
            let responseJson = result;
            if (responseJson) {
                navigate(Routes.INTEGRATIONS);
            }
        }
        );

    }
    
    return (
        <div>
            <h2>::Delete integration::</h2>
            <h3>Are you sure you want to delete this?</h3>
            <div>
                <h4>Integration Information</h4>
                <dl className="row">
                    <dt className="col-sm-2">
                        Integration Name:
                    </dt>
                    <dd className="col-sm-10">
                        {state.name}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Version:
                    </dt>
                    <dd className="col-sm-10">
                        {state.version}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        API Url:
                    </dt>
                    <dd className="col-sm-10">
                        {state.apiUrl}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Type:
                    </dt>
                    <dd className="col-sm-10">
                        {state.type}
                    </dd>
                </dl>

                <form onSubmit={onConfirmation}>
                    <input type="hidden" asp-for="Id" />
                    <button onClick={onCancel} className="btn btn-primary">Back to List</button>
                    &nbsp;&nbsp;
                    <button type="submit" className="btn btn-danger">Delete</button>
                </form>
            </div>
        </div>
    )
}