import SessionManager from "../../auth/SessionManager";
import { EndPoints, postData, getData } from "../../services/AccessAPI";
import { useLocation, useNavigate } from 'react-router-dom';
import { useState, useEffect } from 'react';
import { Routes } from "../../services/Routes";
//import Select from 'react-select'
import TextInput from "../../ui-elements/controls/input/TextInput";
//import CheckBox from "../../ui-elements/controls/input/CheckBox";

export default function CreateIntegrationAccount() {
    const search = useLocation().search;
    const id = new URLSearchParams(search).get('id')
//    const [showAccounts, setShowAccounts] = useState(false);

    useEffect(() => {
/*        getAllAccountsData();
        if (id !== undefined && id !== null) {
            setShowAccounts(true);
            setIntegrationId(Number(id));
        }*/

    }, [id])

    let navigate = useNavigate();

    const [name, setName] = useState("");
    const [username, setUsername] = useState("");
    const [password, setPassword] = useState("");
    const [mfaKey, setMfaKey] = useState("");
    const [integrationId, setIntegrationId] = useState(id);
    const [enabled, setEnabled] = useState(false);
    const [runInterval, setRunInterval] = useState(15);

//    const [accounts, setAccounts] = useState([]);

    const [loading, setLoading] = useState(true);

/*    function getAllAccountsData() {
        getData(EndPoints.ACCOUNTS).then(
            (result) => {
                if (result) {
                    setAccounts(result.map(a => {
                        return {
                            value: a.id,
                            label: a.name
                        }
                    }));
                    setLoading(false);
                }
            }
        );
    }*/

    function onSubmit(e) {
        e.preventDefault();

        let IntegrationAccountObj = {
            name: name,
            username: username,
            password: password,
            mfaKey: mfaKey,
            integrationId: integrationId,
            enabled: enabled,
            runInterval: runInterval,
        }

        postData(EndPoints.INTEGRATIONS_ACCOUNTS, IntegrationAccountObj).then((result) => {
            setLoading(false);
            let responseJson = result;
            if (responseJson) { navigateToIntegrationDashboard(); }
        });
    }

    function navigateToIntegrationDashboard()
    {
        let query = "?id=" + id
        navigate(Routes.INTEGRATIONS_DASHBOARD + query);
    }

    function onClickBack(e){
        e.preventDefault();

        if(SessionManager.getToken()){
            navigateToIntegrationDashboard();
        }else{
            navigate(Routes.LOGIN);
        }   
    }

    return (
        <div className="row">
            <div className="col-md-12">
                <h3>Register new Integration Account</h3>
                <hr />
                <form onSubmit={onSubmit}>
                    <div className="row">
                        <div className="col-md-4">
                            <div className="form-group">
                                <label className="control-label">Name: </label>
                                <TextInput
                                    className="form-control"
                                    value={name}
                                    onChange={(e) => setName(e.target.value)}
                                    name="name"
                                />
                            </div>

                            <div className="form-group">
                                <label className="control-label">Username: </label>
                                <TextInput
                                    className="form-control"
                                    value={username}
                                    onChange={(e) => setUsername(e.target.value)}
                                    name="username"
                                />
                            </div>

                            <div className="form-group">
                                <label className="control-label">Password: </label>
                                <TextInput
                                    className="form-control"
                                    type="password"
                                    value={password}
                                    onChange={(e) => setPassword(e.target.value)}
                                    name="password"
                                />
                            </div>

                            <div className="form-group">
                                <label className="control-label">MFA Key: </label>
                                <TextInput
                                    className="form-control"
                                    value={mfaKey}
                                    onChange={(e) => setMfaKey(e.target.value)}
                                    name="mfaKey"
                                />
                            </div>

                            {/*showAccounts && <div className="form-group">
                                <label className="control-label">Linked Account: </label>
                                <Select className="aa-select" onChange={(e) => setLinkedAccountId(e.value)} name="linkedAccount" options={accounts} isSearchable="true" isLoading={loading} />
                            </div>*/}

                            <div className="form-check">
                                <label>
                                    <input
                                        type="checkbox"
                                        name="enabled"
                                        checked={enabled}
                                        onChange={(e) => setEnabled(!enabled)}
                                        className="form-check-input"
                                    />
                                    Enabled
                                </label>
                            </div>

                            <br />
                            <div className="form-group">
                                <label className="control-label">Run Interval: </label>
                                <TextInput
                                    className="form-control"
                                    value={runInterval}
                                    onChange={(e) => setRunInterval(e.target.value)}
                                    name="runInterval"
                                />
                            </div>

                            <br />
                            <div className="form-group">
                                <input type="button" value="Cancel" onClick={onClickBack} className="btn btn-primary"></input>
                                &nbsp;&nbsp;
                                <input type="submit" value="Register Integration Account" className="btn btn-success"></input> 
                            </div>
                        </div>


                        <div className="col-md-8">
                        </div>
                    </div>
                </form>
            </div>
        </div>
    );
}