import { useNavigate } from "react-router-dom";
import { EndPoints, deleteData, getData } from "../../services/AccessAPI";
import { useEffect } from "react";
import { useState } from 'react';
import { useLocation } from 'react-router-dom';
import { Routes } from "../../services/Routes";

export default function DeleteIntegrationAccount() {
    const search = useLocation().search;
    const id = new URLSearchParams(search).get('id')

    useEffect(() => {
        getData(EndPoints.INTEGRATIONS_ACCOUNTS + "/" + id).then(
            (result) => {
                if (result) {
                    setState({
                        name: result.name,
                        createdOn: result.createdOn,
                        integrationId: result.integrationId,
                        loading: false
                    });
                }
            }
        );
    }, [id])

    let navigate = useNavigate();

    const [state, setState] = useState({
        name: '',
        createdOn: '',
        integrationId: '',
        loading: true
    });

    function navigateToIntegrationDashboard()
    {
        let query = "?id=" + state.integrationId
        navigate(Routes.INTEGRATIONS_DASHBOARD + query);
    }

    function onCancel() {
        navigateToIntegrationDashboard();
    }

    function onConfirmation(e) {
        e.preventDefault();

        deleteData(EndPoints.INTEGRATIONS_ACCOUNTS + "/" + id).then((result) => {
            let responseJson = result;
            if (responseJson) {
                navigateToIntegrationDashboard();
            }
        }
        );

    }
    
    return (
        <div>
            <h2>::Delete Integration Account::</h2>
            <h3>Are you sure you want to delete this?</h3>
            <div>
                <h4>Integration Account Information</h4>
                <dl className="row">
                    <dt className="col-sm-2">
                        Name:
                    </dt>
                    <dd className="col-sm-10">
                        {state.name}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Created On:
                    </dt>
                    <dd className="col-sm-10">
                        {state.createdOn}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Integration ID:
                    </dt>
                    <dd className="col-sm-10">
                        {state.integrationId}
                    </dd>
                </dl>
                
                <form onSubmit={onConfirmation}>
                    <input type="hidden" asp-for="Id" />
                    <button onClick={onCancel} className="btn btn-primary">Back to List</button>
                    &nbsp;&nbsp;
                    <button type="submit" className="btn btn-danger">Delete</button>
                </form>
            </div>
        </div>
    )
}