import { EndPoints, getData, putData } from "../../services/AccessAPI";
import { useNavigate, useLocation } from "react-router-dom";
import { useEffect } from "react";
import { useState } from 'react';
import Select from 'react-select'
import { Routes } from "../../services/Routes";
import TextInput from "../../ui-elements/controls/input/TextInput";

export default function UpdateIntegrationAccount() {
    /*
    ###########################################
    ##### UPDATING ISN'T USEFUL RIGHT NOW #####
    ###########################################
    */
    let navigate = useNavigate();
    const search = useLocation().search;
    const id = new URLSearchParams(search).get('id')
    const [showAccounts, setShowAccounts] = useState(false);

    const [name, setName] = useState("");
    const [username, setUsername] = useState(null);
    const [password, setPassword] = useState(null);
    const [mfaKey, setMfaKey] = useState(null);
    const [integrationId, setIntegrationId] = useState(0);
    const [linkedAccountId, setLinkedAccountId] = useState(0);
    const [enabled, setEnabled] = useState(false);
    const [runInterval, setRunInterval] = useState(0);

    const [accounts, setAccounts] = useState([]);
    const [remoteAccounts, setRemoteAccounts] = useState([]);

    const [loading, setLoading] = useState(false);

    useEffect(() => {
        getAllAccountsData();
        if (id !== undefined && id !== null) {
            setShowAccounts(true);
            //setIntegrationId(Number(id));
        }

        getAllRemoteAccountsData();

        getData(EndPoints.INTEGRATIONS_ACCOUNTS + "/" + id).then(
            (result) => {
                if (result) {
                    setName(result.name);
                    setUsername(result.username);
                    setMfaKey(result.mfaKey);
                    setIntegrationId(result.integrationId);
                    setLinkedAccountId(result.linkedAccountId);
                    setEnabled(result.enabled);
                    setRunInterval(result.runInterval);
                    setLoading(false);
                }
            }
        );
    }, [id])

    function getAllAccountsData() {
        getData(EndPoints.ACCOUNTS).then(
            (result) => {
                if (result) {
                    setAccounts(result.map(a => {
                        return {
                            value: a.id,
                            label: a.name
                        }
                    }));
                    setLoading(false);
                }
            }
        );
    }

    function getAllRemoteAccountsData() {
        getData(EndPoints.INTEGRATIONS_ACCOUNTS + "/" + id + "/" + EndPoints.REMOTEACCOUNTS).then(
            (result) => {
                if (result) {
                    setRemoteAccounts(result);
                    /*setRemoteAccounts(result.map(a => {
                        return {
                            value: a.id,
                            label: a.name
                        }
                    }));*/
                    setLoading(false);
                }
            }
        );
    }
    
    function navigateToIntegrationDashboard()
    {
        let query = "?id=" + integrationId
        navigate(Routes.INTEGRATIONS_DASHBOARD + query);
    }

    function onKeyDown(e) {
        if (e.key === 'Enter') {
            this.update(false);
        }
    }
    
    function onUpdateCancel() {
        navigateToIntegrationDashboard();
    }

    function onSubmit(e) {
        e.preventDefault();

        let integrationAccountProfile = {
            name: name,
            username: username,
            password: password,
            mfaKey: mfaKey,
            linkedAccountId: linkedAccountId,
            enabled: enabled,
            runInterval: runInterval,
        }

        putData(EndPoints.INTEGRATIONS_ACCOUNTS + "/" + id, integrationAccountProfile).then((result) => {
                let responseJson = result;
                
                if (responseJson) {
                    navigateToIntegrationDashboard();
                }
            }
        );
    }

    return(
        <div className="row">
            <div className="col-md-4">
                <h3>Edit Integration Account</h3>
                <form onSubmit={onSubmit}>
                    <div className="form-group">
                        <label className="control-label">Name: </label>
                        <TextInput
                            className="form-control"
                            value={name}
                            onChange={(e) => setName(e.target.value)}
                            name="name"
                            onKeyDown={onKeyDown}
                        />
                    </div>

                    <br />
                    <div className="form-group">
                        <label className="control-label">Username: </label>
                        <TextInput
                            className="form-control"
                            value={username}
                            onChange={(e) => setUsername(e.target.value)}
                            name="username"
                            onKeyDown={onKeyDown}
                        />
                    </div>

                    <br />
                    <div className="form-group">
                        <label className="control-label">Password: </label>
                        <TextInput
                            className="form-control"
                            value={password}
                            onChange={(e) => setPassword(e.target.value)}
                            type="password"
                            name="password"
                            onKeyDown={onKeyDown}
                        />
                    </div>

                    <br />
                    <div className="form-group">
                        <label className="control-label">MFA Key: </label>
                        <TextInput
                            className="form-control"
                            value={mfaKey}
                            onChange={(e) => setMfaKey(e.target.value)}
                            name="mfaKey"
                            onKeyDown={onKeyDown}
                        />
                    </div>

                    {showAccounts && <div className="form-group">
                        <label className="control-label">Linked Account: </label>
                        <Select className="aa-select" onChange={(e) => setLinkedAccountId(e.value)} name="linkedAccount" options={accounts} isSearchable="true" isLoading={loading} />
                    </div>}

                    <div className="form-check">
                        <label>
                            <input
                                type="checkbox"
                                name="enabled"
                                checked={enabled}
                                onChange={(e) => setEnabled(!enabled)}
                                className="form-check-input"
                            />
                            Enabled
                        </label>
                    </div>

                    <br />
                    <div className="form-group">
                        <label className="control-label">Run Interval: </label>
                        <TextInput
                            className="form-control"
                            value={runInterval}
                            onChange={(e) => setRunInterval(e.target.value)}
                            name="runInterval"
                            onKeyDown={onKeyDown}
                        />
                    </div>

                    <br />
                    <div className="form-group">
                        <button onClick={onUpdateCancel} className="btn btn-primary">Cancel</button>
                        &nbsp;&nbsp;
                        <input type="submit" value="Edit" className="btn btn-warning"></input>
                    </div>
                </form>
            </div>
            <div className="col-md-8">

            </div>
        </div>
    );
}