﻿using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace ActiveAllocator.API.Migrations
{
    /// <inheritdoc />
    public partial class RemoteAccountMapping : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_IntegrationAccounts_Accounts_LinkedAccountId",
                table: "IntegrationAccounts");

            migrationBuilder.DropIndex(
                name: "IX_IntegrationAccounts_LinkedAccountId",
                table: "IntegrationAccounts");

            migrationBuilder.DropColumn(
                name: "LinkedAccountId",
                table: "IntegrationAccounts");

            migrationBuilder.CreateTable(
                name: "IntegrationAccountMapping",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Name = table.Column<string>(type: "text", nullable: false),
                    LinkedAccountId = table.Column<int>(type: "integer", nullable: false),
                    Enabled = table.Column<bool>(type: "boolean", nullable: false),
                    ExternalId = table.Column<string>(type: "text", nullable: false),
                    Balance = table.Column<decimal>(type: "numeric", nullable: true),
                    AvailableBalance = table.Column<decimal>(type: "numeric", nullable: true),
                    AccountType = table.Column<string>(type: "text", nullable: false),
                    IntegrationAccountId = table.Column<int>(type: "integer", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_IntegrationAccountMapping", x => x.Id);
                    table.ForeignKey(
                        name: "FK_IntegrationAccountMapping_Accounts_LinkedAccountId",
                        column: x => x.LinkedAccountId,
                        principalTable: "Accounts",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_IntegrationAccountMapping_IntegrationAccounts_IntegrationAc~",
                        column: x => x.IntegrationAccountId,
                        principalTable: "IntegrationAccounts",
                        principalColumn: "Id");
                });

            migrationBuilder.CreateIndex(
                name: "IX_IntegrationAccountMapping_IntegrationAccountId",
                table: "IntegrationAccountMapping",
                column: "IntegrationAccountId");

            migrationBuilder.CreateIndex(
                name: "IX_IntegrationAccountMapping_LinkedAccountId",
                table: "IntegrationAccountMapping",
                column: "LinkedAccountId");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "IntegrationAccountMapping");

            migrationBuilder.AddColumn<int>(
                name: "LinkedAccountId",
                table: "IntegrationAccounts",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateIndex(
                name: "IX_IntegrationAccounts_LinkedAccountId",
                table: "IntegrationAccounts",
                column: "LinkedAccountId");

            migrationBuilder.AddForeignKey(
                name: "FK_IntegrationAccounts_Accounts_LinkedAccountId",
                table: "IntegrationAccounts",
                column: "LinkedAccountId",
                principalTable: "Accounts",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
